## spirv-llvm-translator-21 21.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

if(NOT DEFINED BASE_LLVM_VERSION)
  set (BASE_LLVM_VERSION 21.1.0)
endif(NOT DEFINED BASE_LLVM_VERSION)
set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)

include(FetchContent)
include(FindPkgConfig)

option(LLVM_SPIRV_INCLUDE_TESTS
  "Generate build targets for the llvm-spirv lit tests."
  ${LLVM_INCLUDE_TESTS})

if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)

if(LLVM_SPIRV_BUILD_EXTERNAL)
  # Make sure llvm-spirv gets built when building outside the llvm tree.
  set(LLVM_BUILD_TOOLS ON)
endif(LLVM_SPIRV_BUILD_EXTERNAL)

# Download spirv.hpp from the official SPIRV-Headers repository.
# One can skip this step by manually setting
# LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR path.
if(NOT DEFINED LLVM_TOOL_SPIRV_HEADERS_BUILD AND
   NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
  set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
    "${CMAKE_CURRENT_BINARY_DIR}/SPIRV-Headers")
  message(STATUS "SPIR-V Headers location is not specified. Will try to download
          spirv.hpp from https://github.com/KhronosGroup/SPIRV-Headers into
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
  file(READ spirv-headers-tag.conf SPIRV_HEADERS_TAG)
  # Strip the potential trailing newline from tag
  string(STRIP "${SPIRV_HEADERS_TAG}" SPIRV_HEADERS_TAG)
  FetchContent_Declare(spirv-headers
    GIT_REPOSITORY    https://github.com/KhronosGroup/SPIRV-Headers.git
    GIT_TAG           ${SPIRV_HEADERS_TAG}
    SOURCE_DIR ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}
  )
  FetchContent_MakeAvailable(spirv-headers)
else()
  if(NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
    # This means LLVM_TOOL_SPIRV_HEADERS_BUILD is defined, therefore
    # SPIRV-Headers exist as a subproject.
    set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
      "${CMAKE_SOURCE_DIR}/projects/SPIRV-Headers")
    if(NOT EXISTS ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR})
      message(FATAL_ERROR "No location specified for SPIRV-Headers.
              Try setting the LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
              path or put the project into the llvm/projects folder
              under the name 'SPIRV-Headers'")
    endif()
  endif()
  message(STATUS "Using SPIR-V Headers from
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
endif()

if(LLVM_SPIRV_BUILD_EXTERNAL)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
      C
  )

  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_SPIRV_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_SPIRV_INCLUDE_TESTS)

  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      CodeGen
      Core
      Passes
      Support
      TargetParser
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)
  include(HandleLLVMOptions)
  include(LLVM-Config)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")

  option(CCACHE_ALLOWED "allow use of ccache" TRUE)
  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND AND CCACHE_ALLOWED)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

is_llvm_target_library("SPIRV" spirv_present_result INCLUDED_TARGETS)
if(spirv_present_result)
  message(STATUS "Found SPIR-V Backend")
  set(SPIRV_BACKEND_FOUND TRUE)
  add_compile_definitions(LLVM_SPIRV_BACKEND_TARGET_PRESENT)
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

# first try locating SPIRV-Tools via pkgconfig (the old way)
pkg_search_module(SPIRV_TOOLS SPIRV-Tools)
if (NOT SPIRV_TOOLS_FOUND)
  # then try locating SPIRV-Tools via cmake (the new way)
  find_package(SPIRV-Tools)
  find_package(SPIRV-Tools-tools)
  if (SPIRV-Tools_FOUND AND SPIRV-Tools-tools_FOUND)
    set(SPIRV_TOOLS_FOUND TRUE)
    # check for the existance of library targets in the found packages
    if(TARGET SPIRV-Tools-shared)
      # use the shared libary target if present
      set(SPIRV-Tools-library SPIRV-Tools-shared)
    elseif(TARGET SPIRV-Tools-static)
      # otherwise fallback to the static library target
      set(SPIRV-Tools-library SPIRV-Tools-static)
    else()
      message(FATAL_ERROR "Found SPIRV-Tools package but neither "
              "SPIRV-Tools-shared or SPIRV-Tools-static targets exist.")
    endif()
    set(SPIRV_TOOLS_LDFLAGS ${SPIRV-Tools-library})
    get_target_property(SPIRV_TOOLS_INCLUDE_DIRS ${SPIRV-Tools-library} INTERFACE_INCLUDE_DIRECTORIES)
  endif()
endif()

option(LLVM_SPIRV_ENABLE_LIBSPIRV_DIS "Enable --spirv-tools-dis support.")

if (NOT SPIRV_TOOLS_FOUND AND LLVM_SPIRV_ENABLE_LIBSPIRV_DIS)
  message(STATUS "SPIRV-Tools not found; project will be built without "
          "--spirv-tools-dis support.")
endif()


add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_SPIRV_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_SPIRV_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

## spirv-llvm-translator-21 21.1.0

=== debian/changelog ===
spirv-llvm-translator-21 (21.1.0-3) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-20 20.1.6-1.
  * Update .symbols control file for gcc-15 builds.
  * Mark symbols disappearing with LTO.  (Closes: #1116519)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 29 Sep 2025 11:13:05 +0200

spirv-llvm-translator-21 (21.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 25 Sep 2025 09:04:36 +0300

spirv-llvm-translator-21 (21.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-21.
  * Rename binary packages: *20* => *21*.
  * Build with llvm 21.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update visibility-hidden.patch.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 27 Aug 2025 09:39:59 +0200

spirv-llvm-translator-20 (20.1.6-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.11-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Update .symbols control file for gcc-15 builds.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 12 Sep 2025 03:04:38 +0200

spirv-llvm-translator-20 (20.1.5-1) experimental; urgency=medium

  * New upstream release.
  * Restrict watch file to 20.* releases.
  * Merge changes from spirv-llvm-translator-19 19.1.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Aug 2025 23:08:05 +0200

spirv-llvm-translator-20 (20.1.1-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.6-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Apr 2025 21:47:14 +0200

spirv-llvm-translator-20 (20.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-20.
  * Rename binary packages: *19* => *20*.
  * Build with llvm 20.
  * Update visibility-hidden.patch.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Mar 2025 19:27:29 +0100

spirv-llvm-translator-19 (19.1.11-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.16-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 10 Sep 2025 03:19:41 +0200

spirv-llvm-translator-19 (19.1.10-2) unstable; urgency=medium

  * Update .symbols control file for gcc-15 builds.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 05 Sep 2025 15:42:44 +0200

spirv-llvm-translator-19 (19.1.10-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.15-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Aug 2025 11:56:25 +0200

spirv-llvm-translator-19 (19.1.6-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.11-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Apr 2025 12:14:16 +0200

spirv-llvm-translator-19 (19.1.5-1) unstable; urgency=medium

  * New upstream release.
  * Restrict watch file to 19.* releases.
  * Merge changes from spirv-llvm-translator-18 18.1.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.309.0.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Mar 2025 21:48:51 +0100

spirv-llvm-translator-19 (19.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.3.280.0.
  * Merge changes from spirv-llvm-translator-18 18.1.8-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Jan 2025 09:32:03 +0100

spirv-llvm-translator-19 (19.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.7-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Dec 2024 08:37:24 +0100

spirv-llvm-translator-19 (19.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 20 Sep 2024 03:17:47 +0200

spirv-llvm-translator-19 (19.~~+git20240826-5) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-18 18.1.4-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 16 Sep 2024 14:57:59 +0200

spirv-llvm-translator-19 (19.~~+git20240826-4) unstable; urgency=medium

  * tests: Bump to llvm 19.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 09 Sep 2024 16:13:16 +0300

spirv-llvm-translator-19 (19.~~+git20240826-3) unstable; urgency=medium

  * rules: Don't fail if symbols do not match.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 09 Sep 2024 13:54:46 +0300

spirv-llvm-translator-19 (19.~~+git20240826-2) unstable; urgency=medium

  * Update symbols some more.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 05 Sep 2024 16:57:07 +0300

spirv-llvm-translator-19 (19.~~+git20240826-1) unstable; urgency=medium

  * New upstream snapshot. (Closes: #1079854)
  * Fork source package as spirv-llvm-translator-19.
  * Build with llvm 19, rename binary packages.
  * Update snapshot.sh.
  * symbols: Updated.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 05 Sep 2024 16:53:12 +0300

spirv-llvm-translator-18 (18.1.16-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.16-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Build with g++-14.  (Closes: #1097921)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 08 Sep 2025 18:17:20 +0200

spirv-llvm-translator-18 (18.1.15-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.15-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.


=== debian/control ===
Source: spirv-llvm-translator-21
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 gcc (>= 4:15),
 pkgconf,
 spirv-headers (>= 1.6.1+1.4.321.0-2~),
 spirv-tools,
# keep the clang/llvm version in sync, don't forget debian/tests/control
 libclang-21-dev,
 llvm-21-dev,
 clang-21 <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm21/main

Package: libllvmspirvlib21.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV -- shared library
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the shared library.

Package: libllvmspirvlib-21-dev
Architecture: any
Multi-Arch: same
Depends:
 libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
 ${misc:Depends}
Conflicts:
 libllvmspirvlib-x.y-dev,
Breaks:
 libllvmspirvlib-dev (<< 13.0.0-3~),
Replaces:
 libllvmspirvlib-dev (<< 13.0.0-3~),
 libllvmspirvlib-x.y-dev,
Provides:
 libllvmspirvlib-x.y-dev,
Description: bi-directional translator for LLVM/SPIRV -- development files
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

Package: llvm-spirv-21
Architecture: any
Depends:
 libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the llvm-spirv-${llvm:major} binary.

=== debian/tests/control ===
Tests: upstream-testsuite
Architecture: amd64
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-21,
 llvm-21-dev,
Restrictions:
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite
Features: test-name=upstream-testsuite-flaky
Architecture: !amd64 !s390x
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-21,
 llvm-21-dev,
Restrictions:
 allow-stderr,
 flaky,

Test-Command: true
Features: test-name=spirv-headers-compatibility
Depends:
 spirv-headers,
Restrictions:
 build-needed,
 allow-stderr,
 superficial,

## spirv-llvm-translator-21 21.1.1

=== debian/changelog ===
spirv-llvm-translator-21 (21.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Merge changes from spirv-llvm-translator-20 20.1.7-1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 13 Oct 2025 00:32:03 +0200

spirv-llvm-translator-20 (20.1.7-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.12-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 12 Oct 2025 15:19:10 +0200

spirv-llvm-translator-19 (19.1.12-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 11 Oct 2025 14:15:03 +0200

spirv-llvm-translator-18 (18.1.17-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 10 Oct 2025 20:20:13 +0200

spirv-llvm-translator-17 (17.0.17-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 22:49:07 +0200

spirv-llvm-translator-16 (16.0.17-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 20:17:57 +0200

spirv-llvm-translator-15 (15.0.17-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.16-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 20:04:01 +0200

spirv-llvm-translator-14 (14.0.16-1) unstable; urgency=medium

  * New upstream release.
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Oct 2025 21:43:03 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,6 @@
  libclang-21-dev,
  llvm-21-dev,
  clang-21 <!nocheck>,
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
LLVM_SOVERSION	 = $(LLVM_VERSION).1

AUTOGEN		 = debian/libllvmspirvlib$(LLVM_SOVERSION).install
AUTOGEN		+= debian/libllvmspirvlib$(LLVM_SOVERSION).symbols

%:
	dh $@ --builddir build/

libllvmspirvlib$(LLVM_SOVERSION).%: libllvmspirvlibSOVERSION.%
	ln -s $(<F) $@

autogen: $(AUTOGEN) ;

override_dh_auto_configure: autogen
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH=ON \
		-DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=/usr/include \
		-DBUILD_SHARED_LIBS=ON \
		-DLLVM_SPIRV_INCLUDE_TESTS=ON \
		-DLLVM_EXTERNAL_LIT=/usr/lib/llvm-$(LLVM_VERSION)/build/utils/lit/lit.py \
		-Wno-dev

execute_after_dh_auto_install:
	mv debian/tmp/usr/bin/llvm-spirv debian/tmp/usr/bin/llvm-spirv-$(LLVM_VERSION)

# skip tests on big-endian architectures, uses excessive amount (> 40GB) of disk space
ignore_test_failures	 = $(if $(filter $(DEB_HOST_ARCH),amd64),,-)
override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	$(ignore_test_failures)env LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):$(CURDIR)/build/lib/SPIRV dh_auto_test
endif

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'llvm:major=$(LLVM_VERSION)' \
		-V'llvm:soversion=$(LLVM_SOVERSION)' \

execute_after_dh_clean:
	$(RM) $(AUTOGEN)

update-symbols: debian/libllvmspirvlib$(LLVM_SOVERSION).symbols
	pkgkde-getbuildlogs
	echo "pkgkde-symbolshelper batchpatch -v $(DEB_VERSION_EPOCH_UPSTREAM) $(DEB_SOURCE)_$(DEB_DISTRIBUTION)_logs/$(DEB_SOURCE)_$(DEB_VERSION)_*build"


ifneq (,$(wildcard .git))
upstream:
	git remote show $@ >/dev/null 2>&1 || git remote add $@ $(shell sed -rn 's/Repository: //p' debian/upstream/metadata)
	git fetch $@ --prune
endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?([\d.]*)\.tar\.gz

## spirv-llvm-translator-21 21.1.2

=== debian/changelog ===
spirv-llvm-translator-21 (21.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.8-1.
  * Update B-D after the spirv-tools split.
  * Cherry-pick upstream fix for newer spirv-tools.  (Closes: #1121533)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Dec 2025 22:32:05 +0100

spirv-llvm-translator-20 (20.1.8-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.13-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Nov 2025 23:43:39 +0100

spirv-llvm-translator-19 (19.1.13-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.18-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 25 Nov 2025 21:55:43 +0100

spirv-llvm-translator-18 (18.1.18-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.18-2.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Nov 2025 00:13:22 +0100

spirv-llvm-translator-18 (18.1.17-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-17 17.0.17-2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 18 Nov 2025 22:24:57 +0100

spirv-llvm-translator-17 (17.0.18-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-16 16.0.18-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Nov 2025 09:05:26 +0100

spirv-llvm-translator-17 (17.0.18-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Nov 2025 21:54:25 +0100

spirv-llvm-translator-17 (17.0.17-2) unstable; urgency=medium

  * Build with g++-15.
  * Update .symbols control file for GCC 15 builds.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Nov 2025 00:32:56 +0100

spirv-llvm-translator-16 (16.0.18-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.18-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Nov 2025 01:12:42 +0100

spirv-llvm-translator-15 (15.0.18-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Nov 2025 00:41:35 +0100

spirv-llvm-translator-14 (14.0.17-1) unstable; urgency=medium

  * New upstream release.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 21 Nov 2025 22:05:19 +0100

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,9 @@
  cmake,
  gcc (>= 4:15),
  pkgconf,
- spirv-headers (>= 1.6.1+1.4.321.0-2~),
- spirv-tools,
+ spirv-headers (>= 1.6.1+1.4.328.0),
+ spirv-tools <!nocheck>,
+ spirv-tools-dev,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
  libclang-21-dev,
  llvm-21-dev,

## spirv-llvm-translator-21 21.1.3

=== debian/changelog ===
spirv-llvm-translator-21 (21.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.9-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Dec 2025 02:00:07 +0100

spirv-llvm-translator-20 (20.1.9-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.14-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 23 Dec 2025 22:11:00 +0100

spirv-llvm-translator-19 (19.1.14-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 22 Dec 2025 09:40:00 +0100

spirv-llvm-translator-18 (18.1.19-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Dec 2025 19:22:09 +0100

spirv-llvm-translator-17 (17.0.19-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 23:20:01 +0100

spirv-llvm-translator-16 (16.0.19-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 11:52:55 +0100

spirv-llvm-translator-15 (15.0.19-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.18-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 11:44:25 +0100

spirv-llvm-translator-14 (14.0.18-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.4.328.0.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Dec 2025 23:00:55 +0100

=== debian/tests/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  pkgconf,
  spirv-headers,
  spirv-tools,
+ spirv-tools-dev,
  clang-21,
  llvm-21-dev,
 Restrictions:
@@ -24,6 +25,7 @@
  pkgconf,
  spirv-headers,
  spirv-tools,
+ spirv-tools-dev,
  clang-21,
  llvm-21-dev,
 Restrictions:

## spirv-llvm-translator-21 21.1.4

=== debian/changelog ===
spirv-llvm-translator-21 (21.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.10-1.
  * Cherry-pick cooperative_matrix_constant_null test fix from upstream
    PR 3568 to fix FTBFS with spirv-tools 2026.1.  (Closes: #1127539)
  * Restrict watch file to 21.* releases.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Feb 2026 23:28:47 +0100

spirv-llvm-translator-20 (20.1.10-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.15-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Feb 2026 20:11:59 +0100

spirv-llvm-translator-19 (19.1.15-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.20-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Feb 2026 20:27:04 +0100

spirv-llvm-translator-18 (18.1.20-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-17 17.0.20-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Feb 2026 00:27:34 +0100

spirv-llvm-translator-17 (17.0.20-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.21-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 23:37:19 +0100

spirv-llvm-translator-16 (16.0.21-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.20-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 23:12:51 +0100

spirv-llvm-translator-15 (15.0.20-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.20-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 00:02:21 +0100

spirv-llvm-translator-14 (14.0.20-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.4.335.0.
  * Bump Standards-Version to 4.7.3.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Feb 2026 22:09:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: spirv-llvm-translator-21
 Section: libdevel
-Priority: optional
 Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders:
  Timo Aaltonen <tjaalton@debian.org>,
@@ -10,14 +9,14 @@
  cmake,
  gcc (>= 4:15),
  pkgconf,
- spirv-headers (>= 1.6.1+1.4.328.0),
+ spirv-headers (>= 1.6.1+1.4.335.0),
  spirv-tools <!nocheck>,
  spirv-tools-dev,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
  libclang-21-dev,
  llvm-21-dev,
  clang-21 <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm21/main

=== debian/rules ===
--- 
+++ 
@@ -44,6 +44,8 @@
 
 execute_after_dh_clean:
 	$(RM) $(AUTOGEN)
+	$(RM) -r spirv-llvm-translator-??_*_logs
+	$(RM) -r SPIRV-LLVM-Translator-??.?.? SPIRV-LLVM-Translator-??.?.??
 
 update-symbols: debian/libllvmspirvlib$(LLVM_SOVERSION).symbols
 	pkgkde-getbuildlogs

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(21\.[\d.]*)\.tar\.gz
